<?php

namespace App\Http\Requests\Admin;


use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class BranchRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = ['super_admin', 'admin'];
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('orders'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules = [
            'email' => 'required|email',
            'phone' => 'required|numeric',
            'map' => 'required|url',
        ];
        foreach (languages() as $lang) {
            $lang_rules=[
                'title_'.$lang->local=> 'required|max:25',
                'address_'.$lang->local=> 'required|max:50',
            ];
            $rules= array_merge($rules, $lang_rules);
        }
        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes=[
            'email'=>__('orders.email'),
            'phone'=>__('orders.phone'),
            'map'=>__('orders.map')
        ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local => $service->{'title_'.$lang->local} ?? __('orders.title').' '.$lang->local,
                'address_'.$lang->local => $service->{'address_'.$lang->local} ?? __('orders.address').' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
